//PROTOTYPES
String.prototype.startsWith = function(str) {return (this.match("^"+str)==str)}
// GLOBALS
var font_list=[];
var oShell=new ActiveXObject("WScript.Shell");
var current_tab=-1;
System.Gadget.onSettingsClosing = settings_closing;		

// BUBBLE
var bubble_loc;
var bubble_id;
var bubble_timeout;
function toggle_bubble(x,y,text,id,show_close){
	if ((div_bubble_wrap.style.display!="none")&&(bubble_id==id)){
		close_bubble();
	}else{
		show_bubble(x,y,text,id,show_close);
	}
}
function show_bubble(x,y,text,id,show_close){
	if (show_close){
		div_bubble_close.style.display="";
	}else{
		div_bubble_close.style.display="none";
	}
	bubble_id=id;
	clearTimeout(bubble_timeout);
	bubble_loc={x:x,y:y};
	if (div_bubble_wrap.style.display!=""){
		div_bubble_wrap.style.display="";
		div_bubble_wrap.style.left=-1000;
		img_bubble_arrow_bottom.style.left=-1000;
		img_bubble_arrow_top.style.left=-1000;
	}
	if (div_bubble_text.innerHTML==text){
		adjust_bubble();
	}else{
		div_bubble_text.innerHTML=text;
		setTimeout(adjust_bubble,1);
	}
}
function adjust_bubble(){
	var tmpX,tmpY;
	if (bubble_loc.y>div_bubble.offsetHeight+11){
		img_bubble_arrow_top.style.display="none";
		img_bubble_arrow_bottom.style.display="";
		img_bubble_arrow_bottom.style.left=bubble_loc.x-6;
		img_bubble_arrow_bottom.style.top=bubble_loc.y-15;
		tmpX=bubble_loc.x;
		tmpY=bubble_loc.y-11-div_bubble.offsetHeight;
	}else{
		img_bubble_arrow_top.style.display="";
		img_bubble_arrow_bottom.style.display="none";
		img_bubble_arrow_top.style.left=bubble_loc.x-6;
		img_bubble_arrow_top.style.top=bubble_loc.y+5;
		tmpX=bubble_loc.x;
		tmpY=bubble_loc.y+15;
	}
	div_bubble_wrap.style.left=(tmpX*315/300)*(315-div_bubble.offsetWidth)/315-6;
	div_bubble_wrap.style.top=tmpY;
}
function exit_bubble(id){
	if(id==bubble_id){
		clearTimeout(bubble_timeout);
		bubble_timeout=setTimeout(close_bubble,200);
	}
}
function close_bubble(){
	img_bubble_arrow_bottom.style.display="none";
	img_bubble_arrow_top.style.display="none";
	div_bubble_wrap.style.display="none";
}

// TABS
function tab_over(tab_num){
	if (current_tab==tab_num){return}
	show_bubble(tab_num*22+24,20,tabs[tab_num][0],"tab_"+tab_num,false);
}
function tab_out(tab_num){
	exit_bubble("tab_"+tab_num);
}
function tab_click(tab_num){
	if (current_tab==tab_num){return}
	exit_bubble("tab_"+tab_num);
	current_tab=tab_num;
	img_big_icon.src="settings/tabicons/"+tabs[tab_num][1]+"_2.png";
	img_tab.style.left=tab_num*22+9;
	for (var i in tabs){
		if (i==tab_num){
			document.getElementById("div_main_heading_"+i).style.display="";
			document.getElementById("page_"+tabs[i][1]).style.display="";
			document.getElementById("img_tab_icon_"+i).style.cursor="default";
		}else{
			document.getElementById("div_main_heading_"+i).style.display="none";
			document.getElementById("page_"+tabs[i][1]).style.display="none";
			document.getElementById("img_tab_icon_"+i).style.cursor="";
		}
	}
}

// SETTINGS
var tmp_s=[];
function set_value(el,value_type,value){
	switch (value_type){
		case "date":
			el.value=value;
			if (el.selectedIndex==-1){
				el.nextSibling.nextSibling.value=value;
				el.value=-1;
			}
			update_date_format(el);
			break;
		case "color":
			el.style.backgroundColor=value;
			break;
		case "checkbox":
			el.checked=value;
			break;
		default:
			el.value=value;
			break;
	}
}
function get_value(el,value_type){
	switch (value_type){
		case "color":
			return el.style.backgroundColor;
		case "checkbox":
			return el.checked;
		default:
			return el.value;
	}
}
function settings_closing(event) {
	if (event.closeAction == event.Action.commit) {
		save_all();
	}
	event.cancel = false;
}

// INIT
function init_about(){
	if (parseFloat(System.Gadget.version) < parseFloat(System.Gadget.document.parentWindow.newestVersion)){
		document.getElementById("div_version_alert").innerHTML="<span class=\"div_alert\" ></span>Your version of "+System.Gadget.name+" is outdated. Go <a href=\"javascript:oShell.Run('http://www.homecookedgadgets.com/gadgets.php?id="+System.Gadget.document.parentWindow.gadget_id+"')\">here</a> to get the latest version."
	}
	document.getElementById("div_about_info").innerHTML=System.Gadget.name+" "+System.Gadget.version+" was created by <a href=\"javascript:oShell.Run('http://www.homecookedgadgets.com')\">Home Cooked Gadgets</a>. Stop by and check us out! Feel free to leave any questions, comments or ideas for new gadgets.<br><br>Visit the "+System.Gadget.name+" page <a href=\"javascript:oShell.Run('http://www.homecookedgadgets.com/gadgets.php?id="+System.Gadget.document.parentWindow.gadget_id+"')\">here</a> for more info and to download the latest version. Questions and comments are also welcome on this page.";
}
function init_fonts(){
	var a=dlgHelper.fonts.count;
	font_list = [];
	for (i = 1;i < dlgHelper.fonts.count;i++){
		font_list[i] = dlgHelper.fonts(i)
	}
	font_list.sort();
	
	var sels = document.getElementsByTagName("select");
	for (var i in sels){
		if ((sels[i].id)&&(sels[i].id.startsWith("sel_font_"))){
			add_font_list(sels[i]);
		}
	}
}
function init_tabs(){
	tabs.push(["Default Settings","reset"]);
	tabs.push(["About "+System.Gadget.name,"about"]);
	var t="",t2="";
	for (var i in tabs){
		t+="<img id=\"img_tab_icon_"+i+"\" src=\"settings/tabicons/"+tabs[i][1]+"_1.png\" class=\"img_tab_icon\" style=\"left:"+i*22+";\" onclick=\"tab_click("+i+")\" onmouseover=\"tab_over("+i+")\" onmouseout=\"tab_out("+i+")\" />";
		t2+="<div class=\"div_heading\" id=\"div_main_heading_"+i+"\" style=\"display:none\">"+tabs[i][0]+"</div>";
	}
	div_tab_icons.innerHTML=t;
	div_headings.innerHTML=t2;
	if (parseFloat(System.Gadget.version) < parseFloat(System.Gadget.document.parentWindow.newestVersion)){
		tab_click(tabs.length-1);
	}else{
		tab_click(0);
	}
}

// ARROWS
function arrow_over(b){
	var tmp=b.style.backgroundPosition;
	tmp=tmp.substr(0,tmp.indexOf(" "));
	b.style.backgroundPosition=tmp+" -16px";
}
function arrow_reg(b){
	var tmp=b.style.backgroundPosition;
	tmp=tmp.substr(0,tmp.indexOf(" "));
	b.style.backgroundPosition=tmp+" 0px";
}
function arrow_down(b){
	var tmp=b.style.backgroundPosition;
	tmp=tmp.substr(0,tmp.indexOf(" "));
	b.style.backgroundPosition=tmp+" -32px";
}

// MISC FUNCTIONS
function color_picker(initColor){
	var color = dlgHelper.ChooseColorDlg(initColor);
	color = color.toString(16);
	if (color.length < 6) {
		var sTempString = "000000".substring(0,6-color.length);
		color = sTempString.concat(color);
	}
	if (color == "ff00ff"){color="ff11ff"}
	return "#"+color;
}
function add_font_list(el){
	for (i = 0;i < font_list.length;i++){
		if (font_list[i]){
			el.add(new Option(font_list[i],font_list[i]));
		}
	}
}
function update_date_format(el){
	if (el.value==-1){
		el.nextSibling.nextSibling.style.display="";
	}else{
		el.nextSibling.nextSibling.style.display="none";
		el.nextSibling.nextSibling.value=el.value;
	}
}
